﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ZerimThing
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();

        }

        private void CompilePB_Click(object sender, EventArgs e)
        {
            string qOutput = "";

            /*remember, our output should be just:
             * 
             * I'm going to put a triple arrow (>>>) that shows where we are right now
             * 
             >>> * ACTOR <ActorName> : <Inherited Actor Name> <EditorNumber>
             * {
             *      <Actor Type>
             *      <Actor Properties>
             *      <Actor Sounds>
             *      
             * }
             * 
             * */

            // add in the "ACTOR" text
            qOutput = qOutput + "ACTOR ";

            string tActorName = txtActorName.Text;

            

            // users must provide an actor name
            if(String.IsNullOrWhiteSpace(tActorName))
            {
                MessageBox.Show("You must type an actor name.");
                return;
            }

            qOutput = qOutput + tActorName + " ";

            string tInheritsFrom = txtInheritedActor.Text;
            
            // don't add any inheritance information if the actor doesn't inherit from anything
            if(String.IsNullOrWhiteSpace(tInheritsFrom))
            {
                // don't add the ":" if there's no inheritance
            }
            else
            {
                qOutput = qOutput + ": " + tInheritsFrom + " ";
            }
            

            decimal tEditorNumber = nudEditorNumber.Value;

            qOutput = qOutput + tEditorNumber.ToString();

            
            qOutput = qOutput + Environment.NewLine;

             /*
             * ACTOR <ActorName> : <Inherited Actor Name> <EditorNumber>
             * >>> {
             *      <Actor Type>
             *      <Actor Properties>
             *      <Actor Sounds>
             *      
             * }
             * 
             * */

            qOutput = qOutput + "{" + Environment.NewLine;

             /*
             * ACTOR <ActorName> : <Inherited Actor Name> <EditorNumber>
             * {
             * >>>  <Actor Type>
             *      <Actor Properties>
             *      <Actor Sounds>
             *      
             * }
             * 
             * */

            if(cboThingType.Text == "(No Type)")
            {
                // don't add anything for type if there's no type selected
            }
            else if(cboThingType.Text == "MONSTER")
            {
                qOutput = qOutput + "MONSTER";
            }
            else if(cboThingType.Text == "PROJECTILE")
            {
                qOutput = qOutput + "PROJECTILE";
            }

            // add any other types here....

            else
            {
                // safety check
                MessageBox.Show("Invalid actor type selection.");
                return;

            }

            qOutput = qOutput + Environment.NewLine;

             /*
             * ACTOR <ActorName> : <Inherited Actor Name> <EditorNumber>
             * {
             *      <Actor Type>
             * >>>  <Actor Properties>
             *      <Actor Sounds>
             *      
             * }
             * 
             * */

            qOutput = nudEditorNumber.Text;


            MessageBox.Show(qOutput);
        }

        private void btnProperties_Click(object sender, EventArgs e)
        {
            List<clsProperty> tCopyOfProperties = new List<clsProperty>();

            foreach(clsProperty tProperty in frmMain.SelectedProperties)
            {
                clsProperty tPropertyCopy = new clsProperty(tProperty);
                tCopyOfProperties.Add(tPropertyCopy);
            }

            // whatever you do, don't send frmMain.SelectedProperties in here, or frmProperties will
            // be editing the list even if the user hits cancel !
            frmProperties tPropertiesEditor = new frmProperties(tCopyOfProperties);
            DialogResult tDialogResult = tPropertiesEditor.ShowDialog();

            if(tDialogResult != DialogResult.OK)
            {
                return;
            }

            // now it's ok, they hit the ok button
            frmMain.SelectedProperties = tPropertiesEditor.GetNewPropertiesList();


        }

        // the properties the user selects are added to this list
        private static List<clsProperty> SelectedProperties = new List<clsProperty>();

        internal static readonly List<clsProperty> AllProperties = new List<clsProperty>
        {
            new clsProperty("Optical Drive",    
                            new List<string>    {"Brand",                   "Speed",                "Format"},    
                            new List<Type>      {typeof(System.String),     typeof(System.Single),   typeof(System.String)}, 
                            new List<Object>    {"Asus",                    220.3,                  "BD-ROM"}),

            // or with named parameters...
            new clsProperty(iName:"Hard Drive",  
                            iArgNames:new List<string>      {"Type",                        "Price"},    
                            iArgTypes: new List<Type>       {typeof(System.String),         typeof(System.Double)}, 
                            iArgDefaults: new List<Object>  {"Solid State Drive",           123.4})

        };
  
    }
}
